<template>
  <div class="lucky-wheel-dialog relative">
    <lucky-wheel-entry-button
      v-if="hasValidLuckyWheel && !dialogVisible"
      v-model:dialog-visible="dialogVisible"
      :homepage-entrance="
        availableTickets?.AvailableTickets?.[0]?.HomepageEntrance
      "
    />
    <el-dialog
      v-if="dialogVisible"
      v-model="dialogVisible"
      :show-close="false"
      :close-on-press-escape="false"
      :close-on-click-modal="false"
      width="100%"
      align-center
      :class="{
        __mobile: isMobile,
      }"
    >
      <div class="flex flex-col w-full justify-center items-center gap-8">
        <div class="w-full relative flex justify-center items-center mb-6">
          <div class="flex gap-2 items-center">
            <img
              class=""
              style="width: 40px; height: 40px"
              :src="
                getAssetImage(
                  'assets/theme/common/lucky-wheel/sparkle_fill.png'
                )
              "
              alt=""
            />
            <span
              class="uppercase text-5xl font-black text-white"
              :class="{
                'text-xl': isMobile,
              }"
            >
              {{ $t("Lucky Wheel") }}
            </span>
            <img
              class=""
              style="width: 40px; height: 40px"
              :src="
                getAssetImage(
                  'assets/theme/common/lucky-wheel/cursor_click_fill.png'
                )
              "
              alt=""
            />
          </div>
          <SvgIcon
            v-if="isMobile"
            class="absolute right-0 h-6 w-6 cursor-pointer"
            svg-name="outline-x-mark"
            @click="onClickCloseDialog"
          />
        </div>
        <div class="relative flex justify-center lucky-wheel-section">
          <img
            class="absolute coin-deco-background -top-5"
            :class="{
              __mobile: isMobile,
            }"
            :src="
              getAssetImage(
                'assets/theme/common/lucky-wheel/coin_deco_background.png'
              )
            "
            alt=""
          />
          <div
            class="wheel-container rounded-full"
            :class="{ __mobile: isMobile }"
            style="background: var(--secondary)"
          >
            <img
              class="absolute wheel-pointer"
              :class="{ __mobile: isMobile }"
              :src="
                getAssetImage(
                  'assets/theme/common/lucky-wheel/wheel_pointer.png'
                )
              "
              alt=""
            />
            <img
              class="spinBtn wheel-mid z-10"
              :class="{
                __mobile: isMobile,
              }"
              :src="
                getAssetImage('assets/theme/common/lucky-wheel/wheel_mid.png')
              "
              alt=""
            />
            <img
              class="wheel-border z-10"
              :src="
                getAssetImage(
                  'assets/theme/common/lucky-wheel/wheel_border.png'
                )
              "
              alt=""
            />
            <img
              v-if="spinState.isStoppedSpin"
              class="victor-result"
              :src="
                getAssetImage(
                  'assets/theme/common/lucky-wheel/victor_result.png'
                )
              "
              alt=""
            />
            <div
              class="light-container absolute min-w-[118%] h-[118%] mix-blend-plus-lighter z-30 rounded-full overflow-hidden rotate-[51deg]"
            >
              <img
                v-show="spinState.isDefault"
                class="absolute min-w-[113%] h-[114%] top-[-30px] right-[-28px] mix-blend-plus-lighter z-30 rounded-full"
                :class="{
                  __mobile: isMobile,
                }"
                :src="
                  getAssetImage(
                    'assets/theme/common/lucky-wheel/light-state-1.gif'
                  )
                "
                alt=""
              />
              <img
                v-show="spinState.isSpinning"
                class="absolute min-w-[113%] h-[114%] top-[-30px] right-[-28px] mix-blend-plus-lighter z-30 rounded-full"
                :class="{
                  __mobile: isMobile,
                }"
                :src="
                  getAssetImage(
                    'assets/theme/common/lucky-wheel/light-state-2.gif'
                  )
                "
                alt=""
              />
              <img
                v-show="spinState.isStoppedSpin"
                class="absolute min-w-[113%] h-[114%] top-[-30px] right-[-28px] mix-blend-plus-lighter z-30 rounded-full"
                :class="{
                  __mobile: isMobile,
                }"
                :src="
                  getAssetImage(
                    'assets/theme/common/lucky-wheel/light-state-3.gif'
                  )
                "
                alt=""
              />
            </div>
            <SvgIcon
              v-if="!isMobile"
              class="absolute z-30 close-icon cursor-pointer rotate-[-10deg]"
              svg-name="outline-x-mark"
              @click="onClickCloseDialog"
            />
            <div
              class="wheel mix-blend-hard-light"
              style="animation: spin 8.5s linear infinite"
              :class="{
                __mobile: isMobile,
              }"
            >
              <template
                v-for="(option, index) in luckyWheelOptions.LuckyWheelOptions"
                :key="option.Id"
              >
                <div
                  class="number mix-blend-color-dodge"
                  :style="{
                    '--i': `${index + 1}`,
                    '--clr': `${
                      index % 2 === 0 ? '#f2f2f1' : 'rgba(34, 34, 34, 1)'
                    }`,
                  }"
                ></div>
              </template>
            </div>
            <div
              class="wheel !bg-transparent"
              style="animation: spin 8.5s linear infinite"
              :class="{
                __mobile: isMobile,
              }"
            >
              <template
                v-for="(option, index) in luckyWheelOptions.LuckyWheelOptions"
                :key="option.Id"
              >
                <div
                  class="number"
                  :style="{
                    '--i': `${index + 1}`,
                    '--clr': 'transparent',
                  }"
                >
                  <span
                    :id="String(option.Id)"
                    :style="{
                      color: `${index % 2 === 0 ? 'var(--secondary)' : '#fff'}`,
                    }"
                    class="w-full flex justify-end pr-[67px] option-text items-center"
                    :class="{
                      __mobile: isMobile,
                    }"
                    >{{ CURRENCY_SIGN?.[currency] ?? currency }}{{ option.BonusAmount }}</span
                  >
                </div>
              </template>
            </div>
          </div>
        </div>
        <div class="flex flex-col gap-4 items-center mt-6">
          <div
            class="relative play-button-container cursor-pointer"
            :class="[
              { 'pressed-btn': isClickPlay },
              {
                'pointer-events-none':
                  spinState.isSpinning ||
                  isClickPlay ||
                  !result.RemainingTicketCount ||
                  result?.RemainingTicketCount === 0 ||
                  (spinState.isStoppedSpin && !spinState.settled),
              },
            ]"
            @click.stop="onClickSpin"
          >
            <el-button
              type="primary"
              round
              class="lucky-wheel-play-button"
              :class="{
                __mobile: isMobile,
                'pointer-events-none': !result.RemainingTicketCount,
              }"
              :disabled="!spinState.isDefault"
            >
              {{ $t("play") }}
            </el-button>
            <img
              v-if="!isClickPlay"
              class="absolute top-0 left-0 z-20 soft-light-layer"
              style="mix-blend-mode: soft-light"
              :src="
                getAssetImage('assets/theme/common/lucky-wheel/btn_effect.png')
              "
            />
            <img
              class="absolute top-0 left-0 z-10 multiply-layer"
              style="mix-blend-mode: multiply"
              :src="
                getAssetImage('assets/theme/common/lucky-wheel/btn_effect.png')
              "
            />
            <div
              class="w-full h-full absolute top-0 left-0 rounded-full"
              style="background: var(--primary)"
            ></div>
          </div>
          <div
            class="flex flex-col items-center gap-2 text-white"
            :class="isMobile ? 'text-sm' : 'text-base'"
          >
            <div class="w-full text-center font-bold">
              {{ $t("Spin & Win the Bonus") }}
            </div>
            <div class="flex w-full justify-center gap-1">
              <img
                class=""
                style="width: 24px; height: 24px"
                :src="
                  getAssetImage(
                    'assets/theme/common/lucky-wheel/ticket_icon.png'
                  )
                "
                alt=""
              />
              <div class="font-medium">
                {{ $t("Tickets") }} : {{ result?.RemainingTicketCount ?? 0 }}
                {{ $t("Left") }}
              </div>
            </div>
            <el-button type="primary" @click="onClickHowToGet"
              >{{ $t("How to get tickets") }}?</el-button
            >
          </div>
        </div>
      </div>
      <RewardDialog
        v-if="spinState.settled"
        v-model:spin-state="spinState"
        :reward="result"
        :currency="currency"
      />
      <SomethingWentWrong
        v-if="isSomethingWentWrong"
        v-model:spin-state="spinState"
        v-model:something-went-wrong="isSomethingWentWrong"
        v-model:dialog-visible="dialogVisible"
        :reward="result"
        :error-message="resultErrorMessage"
        :trace-id="traceId"
      />
    </el-dialog>
  </div>
</template>

<script lang="ts" setup>
import LuckyWheelEntryButton from "./LuckyWheelEntryButton.vue";
import RewardDialog from "./RewardDialog.vue";
import SomethingWentWrong from "./SomethingWentWrongDialog.vue";
import useLuckyWheel from "~~/composables/lucky-wheel/useLuckyWheel";

const {
  dialogVisible,
  luckyWheelOptions,
  spinState,
  result,
  isClickPlay,
  currency,
  availableTickets,
  isSomethingWentWrong,
  resultErrorMessage,
  hasValidLuckyWheel,
  traceId,
  onClickCloseDialog,

  onClickSpin,
  onClickHowToGet,
} = useLuckyWheel();
const { getAssetImage } = commonHelper;
const isMobile = !useIsDesktop();
</script>

<style lang="scss">
.wheel-container {
  position: relative;
  width: 360px;
  height: 360px;
  display: flex;
  justify-content: center;
  align-items: center;
  transform: rotate(100deg);
  &.__mobile {
    width: 260px;
    height: 260px;
  }

  .spinBtn {
    position: absolute;
    width: 60px;
    height: 60px;
    border-radius: 50%;
    background: #fff;
    z-index: 10;
    &.wheel-mid {
      width: 72px;
      height: 72px;
      &.__mobile {
        width: 40px;
        height: 40px;
      }
    }
  }

  .close-icon {
    width: 48px;
    height: 48px;
    top: -22%;
    right: 100%;
  }

  .wheel {
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    background: #333;
    border-radius: 50%;
    overflow: hidden;
    box-shadow: 0 0 0 32px var(--secondary);
    transition: transform 5s ease-in-out;
    transform-origin: center;
    &.__mobile {
      box-shadow: 0 0 0 24px var(--secondary);
    }
  }

  .number {
    position: absolute;
    width: 50%;
    height: 50%;
    background: var(--clr);
    transform-origin: bottom right;
    transform: rotate(calc(36deg * var(--i)));
    clip-path: polygon(0 0, 50% 0, 100% 100%, 0 50%);
    display: flex;
    justify-content: center;
    align-items: center;
    user-select: none;
    cursor: pointer;

    span {
      position: relative;
      transform: rotate(225deg);
      font-size: 1.5em;
      font-weight: 700;
      color: #fff;
      padding-right: 67px;
      display: inline-block;
      max-width: 200px;
      white-space: nowrap;
      overflow: hidden;
      text-overflow: ellipsis;
      text-align: right;
      &.__mobile {
        font-weight: 700;
        font-size: 14px;
        padding-right: 54px;
      }
    }
  }
}
.lucky-wheel-dialog {
  min-width: 120px;
  bottom: 3%;
  right: 5%;
  .el-dialog {
    background: transparent;
    outline: unset;
    margin-top: auto;
    margin-bottom: auto;
    &.__mobile {
      overflow: hidden;
      margin-top: auto;
    }
  }
  .play-button-container {
    &.pressed-btn {
      transform: translateY(7px);
    }
    .lucky-wheel-play-button {
      border: unset;
      width: 192px;
      height: 78px;
      transition: transform 0.002s ease;
      background: transparent !important;
      position: relative;
      z-index: 20;
      box-shadow: 0px 20px 25px -6px var(--primary);
      &.is-disabled {
        opacity: 1;
      }
      span {
        text-shadow: -2px 0px 0px var(--primary), -2px -2px 0 var(--primary),
          2px -2px 0 var(--primary), 2px 2px 0 var(--primary),
          -2px 2px 0 var(--primary);
        color: var(--primary),
          linear-gradient(0deg, rgba(0, 0, 0, 0.7) 0%, rgba(0, 0, 0, 0.7) 100%);
        font-weight: 900;
        font-size: 40px;
        text-transform: uppercase;
      }
      &.__mobile {
        width: 128px;
        height: 52px;
        box-shadow: 0px 8px 24px -2px var(--primary);

        span {
          font-weight: 900;
          font-size: 24px;
        }
      }
    }
    .el-button.is-round {
      border-radius: 47px;
      font-size: 32px;
    }
  }
  .lucky-wheel-section {
    width: 600px;
    .coin-deco-background {
      width: 600px;
      height: 450px;
      animation: bounceUpDown 10s infinite;
      &.__mobile {
        width: 70%;
        height: 330px;
      }
    }
  }
  .wheel-pointer {
    z-index: 31;
    right: 52%;
    top: -38px;
    transform: rotate(-10deg);
    width: 44px;
    height: 68px;
    &.__mobile {
      width: 33px;
      height: 54px;
      top: -29px;
    }
  }
  .wheel-border {
    height: 118%;
    min-width: 118%;
    position: absolute;
    mix-blend-mode: hard-light;
  }
  .victor-result {
    transform: rotate(-99deg);
    position: absolute;
    top: -21px;
    right: -6%;
    min-width: 112%;
    height: 112%;
    z-index: 9;
  }
  .light-container {
    img {
      &.__mobile {
        top: -17px;
        right: -21px;
        height: 111%;
        min-width: 114%;
      }
    }
  }
}
@-moz-keyframes spin {
  100% {
    -moz-transform: rotate(360deg);
  }
}
@-webkit-keyframes spin {
  100% {
    -webkit-transform: rotate(360deg);
  }
}
@keyframes spin {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}
@keyframes bounceUpDown {
  0% {
    transform: scale(1);
  }
  50% {
    transform: scale(0.9);
  }
  100% {
    transform: scale(1);
  }
}
</style>
